module Sphere exposing (..)

import BoundedInt exposing (BoundedInt)

type alias Sphere =
    { name : String
    , dots : BoundedInt
    , affinity : Bool
    }

freebieCost : Int
freebieCost = 7

changeSphereInList : List Sphere -> Sphere -> List Sphere
changeSphereInList spheres sphere =
    List.map ( changeSphere sphere ) spheres

changeSphere : Sphere -> Sphere -> Sphere
changeSphere newSphere sphere =
    if isSphere newSphere.name sphere
    then
        newSphere
    else
        sphere

isSphere : String -> Sphere -> Bool
isSphere name sphere =
    sphere.name == name

getDotsOfSphereInList : List Sphere -> String -> Maybe BoundedInt
getDotsOfSphereInList spheres name =
    let
        maybeSphere = spheres
            |> List.filter ( isSphere name )
            |> List.head
    in
        case maybeSphere of
            Nothing -> Nothing
            Just sphere ->
                Just sphere.dots

dots : Int -> BoundedInt
dots value =
    BoundedInt.new value 0 5